Skip Menu |
 

This queue is for tickets about the Scalar-List-Utils CPAN distribution.

Report information
The Basics
Id: 112003
Status: new
Priority: 0/
Queue: Scalar-List-Utils

People
Owner: Nobody in particular
Requestors: dolmen [...] cpan.org
Cc:
AdminCc:

Bug Information
Severity: (no value)
Broken in: 1.41
Fixed in: (no value)



Subject: Sub::Util 1.41 incorrectly installed on perl 5.10.1

$ perl -MList::Util -MSub::Util=subname -E 'say "perl $^V"; say "Sub::Util $Sub::Util::VERSION"; say $INC{"Sub/Util.pm"}; say "List::Util $List::Util::VERSION"; $INC{"List/Util.pm"}; say subname(subname)'
perl v5.10.1
Sub::Util 1.41
/home/dolmen/.plenv/versions/5.10.1/lib/perl5/site_perl/5.10.1/x86_64-linux/Sub/Util.pm
List::Util 1.21
Undefined subroutine &Sub::Util::subname called at -e line 1.



  @INC:
    /home/dolmen/.plenv/versions/5.10.1/lib/perl5/5.10.1/x86_64-linux
    /home/dolmen/.plenv/versions/5.10.1/lib/perl5/5.10.1
    /home/dolmen/.plenv/versions/5.10.1/lib/perl5/site_perl/5.10.1/x86_64-linux
    /home/dolmen/.plenv/versions/5.10.1/lib/perl5/site_perl/5.10.1


Note that the directories for List/Util.pm and Sub/Util.pm are not the same.
And I have 2 different versions of Util.so

$ find /home/dolmen/.plenv/versions/5.10.1/lib/perl5 -name Util.so -o -name Util.pm | grep -E '(List|Sub)/Util' | xargs ls -l
-r-xr-xr-x 1 dolmen dolmen 32988 juin   8  2014 /home/dolmen/.plenv/versions/5.10.1/lib/perl5/5.10.1/x86_64-linux/auto/List/Util/Util.so
-r--r--r-- 1 dolmen dolmen  6698 juin   8  2014 /home/dolmen/.plenv/versions/5.10.1/lib/perl5/5.10.1/x86_64-linux/List/Util.pm
-r-xr-xr-x 1 dolmen dolmen 59486 févr. 13 16:11 /home/dolmen/.plenv/versions/5.10.1/lib/perl5/site_perl/5.10.1/x86_64-linux/auto/List/Util/Util.so
-r--r--r-- 1 dolmen dolmen 14226 sept.  5  2014 /home/dolmen/.plenv/versions/5.10.1/lib/perl5/site_perl/5.10.1/x86_64-linux/List/Util.pm
-r--r--r-- 1 dolmen dolmen  4431 sept.  5  2014 /home/dolmen/.plenv/versions/5.10.1/lib/perl5/site_perl/5.10.1/x86_64-linux/Sub/Util.pm



So it appears that when Sub::Util 1.41 is installed, Util.so is not upgraded (or at least not installed in directory that .

Other dependencies relevant to install:
ExtUtils::MakeMaker 6.55_02
ExtUtils::Install 1.54

-- 
Olivier Mengué - http://perlresume.org/DOLMEN
I tried to install Devel::TraceUse to do more disgnostics of versions of modules used by Makefile.PL.
As a result, the following modules were upgraded:
- ExtUtils::CBuilder 0.2602 -> 0.280224
- ExtUtils::ParseXS 2.2002 -> 3.30
- TAP::Harness 3.17 -> 3.36
- Module::Build v0.340201 -> 0.4216

When reinstalling PEVANS/Scalar-List-Utils-1.41.tar.gz, I now have Util.so in the proper place and the issue is fixed.

$ find /home/dolmen/.plenv/versions/5.10.1/lib/perl5 -name Util.so -o -name Util.pm | grep -E '(List|Sub)/Util' | xargs ls -l
-r-xr-xr-x 1 dolmen dolmen 59486 févr. 13 16:48 /home/dolmen/.plenv/versions/5.10.1/lib/perl5/5.10.1/x86_64-linux/auto/List/Util/Util.so
-r--r--r-- 1 dolmen dolmen 14226 sept.  5  2014 /home/dolmen/.plenv/versions/5.10.1/lib/perl5/5.10.1/x86_64-linux/List/Util.pm
-r--r--r-- 1 dolmen dolmen  4431 sept.  5  2014 /home/dolmen/.plenv/versions/5.10.1/lib/perl5/5.10.1/x86_64-linux/Sub/Util.pm
-r-xr-xr-x 1 dolmen dolmen 59486 févr. 13 16:11 /home/dolmen/.plenv/versions/5.10.1/lib/perl5/site_perl/5.10.1/x86_64-linux/auto/List/Util/Util.so
-r--r--r-- 1 dolmen dolmen 14226 sept.  5  2014 /home/dolmen/.plenv/versions/5.10.1/lib/perl5/site_perl/5.10.1/x86_64-linux/List/Util.pm
-r--r--r-- 1 dolmen dolmen  4431 sept.  5  2014 /home/dolmen/.plenv/versions/5.10.1/lib/perl5/site_perl/5.10.1/x86_64-linux/Sub/Util.pm

$ perl -MList::Util -MSub::Util=subname -E 'say "perl $^V"; say "Sub::Util $Sub::Util::VERSION"; say $INC{"Sub/Util.pm"}; say "List::Util $List::Util::VERSION"; $INC{"List/Util.pm"}; say subname(\&subname)'
perl v5.10.1
Sub::Util 1.41
/home/dolmen/.plenv/versions/5.10.1/lib/perl5/5.10.1/x86_64-linux/Sub/Util.pm
List::Util 1.41
Sub::Util::subname


So the issue has been fixed by the install of one of the dependencies listed above.


-- 
Olivier Mengué - http://perlresume.org/DOLMEN
This issue would occur in the same way with Scalar-List-Util 1.43 as the dependencies (and in particular the build dependencies) have not changed since 1.41.


-- 
Olivier Mengué - http://perlresume.org/DOLMEN
Same issue reported on IRC #mojo
http://irclog.perlgeek.de/mojo/2014-12-04#i_9760764

... and reported in https://rt.cpan.org/Ticket/Display.html?id=100863

(thanks to jberger for the links)

-- 
Olivier Mengué - http://perlresume.org/DOLMEN


This service is sponsored and maintained by Best Practical Solutions and runs on Perl.org infrastructure.

Please report any issues with rt.cpan.org to rt-cpan-admin@bestpractical.com.